#include <bits/stdc++.h>
#define endl "\n"
using namespace std;

typedef uint64_t ll;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;

    ll knjige[n], max_br[n] = {}, p;
    long long max_br_i[n] = {};
    for (int i = 0; i < n; i++)
        cin >> knjige[i];

    for (int i = n - 1; i >= 0; i--){
        if (i == n - 1){
            max_br[i] = knjige[i];
            max_br_i[i] = i;
        }
        else if (knjige[i] >= max_br[i + 1]){
            max_br[i] = knjige[i];
            max_br_i[i] = i;
        }
        else{
            max_br[i] = max_br[i + 1];
            max_br_i[i] = max_br_i[i + 1];
        }
    }

    bool b = 0;
    for (int i = 0; i < n - 1 && !b; i++)
        if (knjige[i] <= max_br[i + 1]){
            p = knjige[i];
            knjige[i] = knjige[max_br_i[i]];
            knjige[max_br_i[i]] = p;
            b = 1;
        }


    if (b == 0){
        p = knjige[n - 1];
        knjige[n - 1] = knjige[n - 2];
        knjige[n - 2] = p;
    }

    for (auto i : knjige)
        cout << i << " ";
    cout << endl;

    return 0;
}